package ru.ulstu.extractor.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import ru.ulstu.extractor.repository.CommitRepository;

import java.util.List;
import java.util.stream.Collectors;

@Controller
public class StatisticController {
    private final CommitRepository commitRepository;

    public StatisticController(CommitRepository commitRepository) {
        this.commitRepository = commitRepository;
    }

    @GetMapping("/statistic")
    public String indexBranch(
            Model model) {
        String[] continents = {
                "Africa", "Antarctica", "Asia", "Australia",
                "Europe", "North America", "Sourth America"
        };


        model.addAttribute("continents", continents);
        model.addAttribute("array", new int[]{1, 2, 3});
        List<String[]> listArr = commitRepository.getCommitAuthorStatistic().stream()
                .map(stat -> new String[]{stat.getAuthor(), stat.getCountCommit().toString()})
                .collect(Collectors.toList());
        String[][] commitAuthorData = listArr.toArray(String[][]::new);
        model.addAttribute("commitAuthorData", findPercent(commitAuthorData));
        return "statistic";
    }

    public String[][] findPercent(String[][] commitAuthorData) {
        long sum = 0;
        for (int i = 0; i < commitAuthorData.length; i++) {
            sum = sum + Integer.parseInt(commitAuthorData[i][1]);
        }
        System.out.println(sum);
        long percent = 0;
        for (int i = 0; i < commitAuthorData.length; i++) {
            percent = Integer.parseInt(commitAuthorData[i][1]) * 100 / sum;
            commitAuthorData[i][1] = "";
        }
        return commitAuthorData;
    }
}
